/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .text
        .global glcdSetPixel            // used D0,D1,T0,T1 stack 2
glcdSetPixel:
#ifdef USE_HIGHCOLOR
        _movw   D0, P2                  // save color
#else
        mov     D0, P2
#endif

        .global glcdDoSetPixel
glcdDoSetPixel:
#ifdef USE_CLIPPING
        lds     T0, glcd_Flags          // check if we must clip
        sbrs    T0, flagClipping
        rjmp    glcdDoSetPixel1

        lds     T0, glcd_Clip_X1        // check clipping x,y in glcd_Clip
        cp      X1, T0
        brlo    glcdDoSetPixel2
        lds     T0, glcd_Clip_X2
        cp      T0, X1
        brlo    glcdDoSetPixel2
        lds     T0, glcd_Clip_Y1
        cp      Y1, T0
        brlo    glcdDoSetPixel2
        lds     T0, glcd_Clip_Y2
        cp      T0, Y1
        brlo    glcdDoSetPixel2
glcdDoSetPixel1:
#endif
        mov     X2, X1                  // x1 = x, y1 = y, x2 = x, y2 = y
        mov     Y2, Y1
        fcall   glcdSetAddr

#ifdef USE_HIGHCOLOR
        movw    T0, D0
        fjmp    glcdPutPixelT
#else
        mov     T1, D0
        fjmp    glcdDispData
#endif
glcdDoSetPixel2:
        ret

.end
